import * as React from 'react';
import { BaseComponent, IRenderFunction, IClassNames } from '../../Utilities';
import { IColumn } from './DetailsList.types';
import { ITooltipHostProps } from '../../Tooltip';
import { IDragDropHelper } from './../../utilities/dragdrop/interfaces';
import { IDetailsHeaderStyles } from './DetailsHeader.types';
export interface IDetailsColumnProps extends React.Props<DetailsColumn> {
    componentRef?: () => void;
    column: IColumn;
    columnIndex: number;
    parentId?: string;
    onRenderColumnHeaderTooltip?: IRenderFunction<ITooltipHostProps>;
    onColumnClick?: (ev: React.MouseEvent<HTMLElement>, column: IColumn) => void;
    onColumnContextMenu?: (column: IColumn, ev: React.MouseEvent<HTMLElement>) => void;
    dragDropHelper?: IDragDropHelper | null;
    isDraggable?: boolean;
    setDraggedItemIndex?: (itemIndex: number) => void;
    isDropped?: boolean;
    headerClassNames: IClassNames<IDetailsHeaderStyles>;
}
export declare class DetailsColumn extends BaseComponent<IDetailsColumnProps> {
    private _root;
    private _dragDropSubscription;
    constructor(props: IDetailsColumnProps);
    render(): (JSX.Element | null)[];
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentDidUpdate(): void;
    private _onRenderColumnHeaderTooltip;
    private _onColumnClick;
    private _getColumnDragDropOptions;
    private _onDragStart;
    private _onDragEnd;
    private _onColumnContextMenu;
    private _onRootMouseDown;
}
